#include <time.h>
#include <string.h>
#include <stdio.h>
#include <malloc.h>
#include "log.h"

inline char *itoa(int num, char *c) { sprintf(c, "%d", num); return c; }
inline char *ltoa(long num, char *c) { sprintf(c, "%ld", num); return c; }

log &log::operator<< (unsigned int x)	{char c[11];return append(itoa(x,c));}
log &log::operator<< (unsigned long x)	{char c[11];return append(ltoa(x,c));}
log &log::operator<< (signed long x)	{char c[11];return append(ltoa(x,c));}
log &log::operator<< (signed int x)	{char c[11];return append(itoa(x,c));}
log &log::operator<< (char &x)		{return append((char *)x);}
log &log::operator<< (char *x)		{return append(x);}

void log::flush()
{
  if (!logstr)
    return;
  else {
    time_t ct = time(0);
    char *tmstr = asctime(localtime(&ct));
    *(tmstr + strlen(tmstr) - 1) = '\0';
    fprintf(stderr, "%-19.19s :: %s\n", tmstr, logstr);
    length = 1;
    if (logstr)
      free(logstr);
    logstr = NULL;
  }
}

log & log::append(const char *x)
{
  char *oldstr = NULL;

  if (!x)
    return *this;

  if (logstr) {
    oldstr = (char *)malloc(length);
    strcpy(oldstr, logstr);
  }

  length += strlen(x);
  logstr = (char *)realloc(logstr, length);
  if (oldstr)
    strcpy(logstr, oldstr);
  else
    *logstr = '\0';
  strcat(logstr, x);

  if (oldstr && *oldstr)
    free(oldstr);

  return *this;
}
